﻿///////////////////////////////////////////////////////////////////////////////////////////////////
// 
//  ACT距離計算サービス サンプルプログラム
//  ArrayExtensionMethodsクラス
//
//  Copyrights (c) 2016 Advanced Core Technologies, Inc. All rights reserved.
//
//  2016/01/26 Rev.1.0.0.0 MOTO 作成
//
///////////////////////////////////////////////////////////////////////////////////////////////////

using System;

namespace ACTSOAPCSCalcOneWay
{
    /// <summary>
    /// Arrayクラスの拡張メソッドを定義します。
    /// </summary>
    internal static class ArrayExtensionMethods
    {
        /// <summary>
        /// 配列のstart番目の要素からlength分の長さのコピーを返します。
        /// </summary>
        /// <typeparam name="T">コピーする配列の型</typeparam>
        /// <param name="source">コピー元の配列</param>
        /// <param name="start">コピーを開始するインデックス</param>
        /// <param name="length">コピーする長さ</param>
        /// <returns>コピーした要素を格納した配列。</returns>
        public static T[] Copy<T>(this T[] source, int start, int length)
        {
            if (start < 0 || start >= source.Length)
            {
                throw new ArgumentOutOfRangeException("start");
            }
            if (length <= 0 || start + length > source.Length)
            {
                throw new ArgumentException("length");
            }

            T[] newArray = new T[length];
            Array.Copy(source, start, newArray, 0, length);

            return newArray;
        }
    }
}
